'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (config) {
  return function (css) {
    const unwrappedConfig = config();

    css.walkAtRules('tailwind', atRule => {
      if (atRule.params === 'utilities') {
        const utilities = _postcss2.default.root({
          nodes: _lodash2.default.flatten([(0, _lists2.default)(unwrappedConfig), (0, _forms2.default)(unwrappedConfig), (0, _textSizes2.default)(unwrappedConfig), (0, _textWeights2.default)(unwrappedConfig), (0, _textFonts2.default)(unwrappedConfig), (0, _textColors2.default)(unwrappedConfig), (0, _textLeading2.default)(unwrappedConfig), (0, _textTracking2.default)(unwrappedConfig), (0, _textAlign2.default)(unwrappedConfig), (0, _textWrap2.default)(unwrappedConfig), (0, _textStyle2.default)(unwrappedConfig), (0, _verticalAlign2.default)(unwrappedConfig), (0, _backgroundColors2.default)(unwrappedConfig), (0, _backgroundPositions2.default)(unwrappedConfig), (0, _backgroundSize2.default)(unwrappedConfig), (0, _borderWidths2.default)(unwrappedConfig), (0, _borderColors2.default)(unwrappedConfig), (0, _borderStyles2.default)(unwrappedConfig), (0, _rounded2.default)(unwrappedConfig), (0, _display2.default)(unwrappedConfig), (0, _position2.default)(unwrappedConfig), (0, _overflow2.default)(unwrappedConfig), (0, _sizing2.default)(unwrappedConfig), (0, _spacing2.default)(unwrappedConfig), (0, _shadows2.default)(unwrappedConfig), (0, _flex2.default)(unwrappedConfig), (0, _floats2.default)(unwrappedConfig), (0, _visibility2.default)(unwrappedConfig), (0, _zIndex2.default)(unwrappedConfig), (0, _opacity2.default)(unwrappedConfig), (0, _userSelect2.default)(unwrappedConfig), (0, _pointerEvents2.default)(unwrappedConfig), (0, _resize2.default)(unwrappedConfig), (0, _cursor2.default)(unwrappedConfig)])
        });

        if (_lodash2.default.get(unwrappedConfig, 'options.important', false)) {
          utilities.walkDecls(decl => decl.important = true);
        }

        const tailwindClasses = _postcss2.default.root({
          nodes: [...(0, _container2.default)(unwrappedConfig), (0, _responsive2.default)(utilities)]
        });

        (0, _applyClassPrefix2.default)(tailwindClasses, _lodash2.default.get(unwrappedConfig, 'options.prefix', ''));

        atRule.before(tailwindClasses);
        atRule.remove();
      }
    });
  };
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _postcss = require('postcss');

var _postcss2 = _interopRequireDefault(_postcss);

var _applyClassPrefix = require('../util/applyClassPrefix');

var _applyClassPrefix2 = _interopRequireDefault(_applyClassPrefix);

var _backgroundColors = require('../generators/backgroundColors');

var _backgroundColors2 = _interopRequireDefault(_backgroundColors);

var _backgroundPositions = require('../generators/backgroundPositions');

var _backgroundPositions2 = _interopRequireDefault(_backgroundPositions);

var _backgroundSize = require('../generators/backgroundSize');

var _backgroundSize2 = _interopRequireDefault(_backgroundSize);

var _borderColors = require('../generators/borderColors');

var _borderColors2 = _interopRequireDefault(_borderColors);

var _borderStyles = require('../generators/borderStyles');

var _borderStyles2 = _interopRequireDefault(_borderStyles);

var _borderWidths = require('../generators/borderWidths');

var _borderWidths2 = _interopRequireDefault(_borderWidths);

var _container = require('../generators/container');

var _container2 = _interopRequireDefault(_container);

var _cursor = require('../generators/cursor');

var _cursor2 = _interopRequireDefault(_cursor);

var _display = require('../generators/display');

var _display2 = _interopRequireDefault(_display);

var _flex = require('../generators/flex');

var _flex2 = _interopRequireDefault(_flex);

var _floats = require('../generators/floats');

var _floats2 = _interopRequireDefault(_floats);

var _forms = require('../generators/forms');

var _forms2 = _interopRequireDefault(_forms);

var _lists = require('../generators/lists');

var _lists2 = _interopRequireDefault(_lists);

var _opacity = require('../generators/opacity');

var _opacity2 = _interopRequireDefault(_opacity);

var _overflow = require('../generators/overflow');

var _overflow2 = _interopRequireDefault(_overflow);

var _pointerEvents = require('../generators/pointerEvents');

var _pointerEvents2 = _interopRequireDefault(_pointerEvents);

var _position = require('../generators/position');

var _position2 = _interopRequireDefault(_position);

var _resize = require('../generators/resize');

var _resize2 = _interopRequireDefault(_resize);

var _responsive = require('../util/responsive');

var _responsive2 = _interopRequireDefault(_responsive);

var _rounded = require('../generators/rounded');

var _rounded2 = _interopRequireDefault(_rounded);

var _shadows = require('../generators/shadows');

var _shadows2 = _interopRequireDefault(_shadows);

var _sizing = require('../generators/sizing');

var _sizing2 = _interopRequireDefault(_sizing);

var _spacing = require('../generators/spacing');

var _spacing2 = _interopRequireDefault(_spacing);

var _textAlign = require('../generators/textAlign');

var _textAlign2 = _interopRequireDefault(_textAlign);

var _textColors = require('../generators/textColors');

var _textColors2 = _interopRequireDefault(_textColors);

var _textFonts = require('../generators/textFonts');

var _textFonts2 = _interopRequireDefault(_textFonts);

var _textLeading = require('../generators/textLeading');

var _textLeading2 = _interopRequireDefault(_textLeading);

var _textSizes = require('../generators/textSizes');

var _textSizes2 = _interopRequireDefault(_textSizes);

var _textStyle = require('../generators/textStyle');

var _textStyle2 = _interopRequireDefault(_textStyle);

var _textTracking = require('../generators/textTracking');

var _textTracking2 = _interopRequireDefault(_textTracking);

var _textWeights = require('../generators/textWeights');

var _textWeights2 = _interopRequireDefault(_textWeights);

var _textWrap = require('../generators/textWrap');

var _textWrap2 = _interopRequireDefault(_textWrap);

var _userSelect = require('../generators/userSelect');

var _userSelect2 = _interopRequireDefault(_userSelect);

var _verticalAlign = require('../generators/verticalAlign');

var _verticalAlign2 = _interopRequireDefault(_verticalAlign);

var _visibility = require('../generators/visibility');

var _visibility2 = _interopRequireDefault(_visibility);

var _zIndex = require('../generators/zIndex');

var _zIndex2 = _interopRequireDefault(_zIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }