'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return function (css) {
    css.walkAtRules('focusable', atRule => {
      atRule.walkRules(rule => {
        // Might be wise to error if the rule has multiple selectors,
        // or weird compound selectors like .bg-blue>p>h1
        rule.selectors = [rule.selector, `.focus\\:${rule.selector.slice(1)}:focus`];
      });

      atRule.before((0, _cloneNodes2.default)(atRule.nodes));

      atRule.remove();
    });
  };
};

var _cloneNodes = require('../util/cloneNodes');

var _cloneNodes2 = _interopRequireDefault(_cloneNodes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }